import sys
from gi.repository import Gtk
from window import TahrirWindow
from document import Document

class TahrirApp(Gtk.Application):
    def __init__(self):
        Gtk.Application.__init__(self)
        self.documents = [];
        self.docsCount = 0;

    def newDocument(self, filename):
        doc = Document()
        if(filename != None):
            doc.setFilename(filename)
            doc.fetchTitle()
            doc.fetchContent()
        self.docsCount += 1
        title = doc.get_title()
        doc.set_modified(False)
        self._win.notebook.append_page(doc, Gtk.Label(_(title)))
        self._win.toolbar.documentsBox.append(str(self.docs_count),title)
        self._win.toolbar.documentsBox.set_active_id(str(self.docs_count))
        self._win.notebook.set_current_page(-1)
        self._win.notebook.show_all()

    def do_startup(self):
        Gtk.Application.do_startup(self)

    def do_activate(self):
        self._win = TahrirWindow(self)
        self._win.present()

if __name__ == '__main__':
    app = TahrirApp()
    r = app.run(sys.argv)
    sys.exit(r)
