from gi.repository import Gtk, GtkSource

class Document(Gtk.ScrolledWindow):
    def __init__(self):
        Gtk.ScrolledWindow.__init__(self)
        self.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
        self.view = GtkSource.View()
        self.add(self.view)
        self.buffer = GtkSource.Buffer()
        self.view.set_buffer(self.buffer)
        self.filename = None
        self.buffer.connect('modified-changed', self._onBufferChanged)

    def getModified(self):
        return self.buffer.get_modified()

    def setModified(self, boolean):
        self.buffer.set_modified(boolean)

    def getTitle(self):
        return self.title

    def setTitle(self, new_title):
        self.title = new_title

    def getFilename(self):
        return self.filename

    def setFilename(self, new_filename):
        self.filename = new_filename

    def fetchTitle(self):
        title = self.filename.split("/")[-1]
        self.set_title(title)

    def fetchContent(self):
        with open(self.filename, 'r') as f:
            content = f.read()
            self.buffer.set_text(content)

    def save(self):
        with open(self.filename, 'w') as f:
            content = self.buffer.get_text(self.buffer.get_start_iter(),
                    self.buffer.get_end_iter(), True)
            f.seek(0)
            f.write(content)
        self.set_modified(False)

    def _onBufferChanged(self, Buffer):
        self.main_window.toolbar.showSaveIcon(Buffer.get_modified())
