import sys
from toolbar import TahrirToolbar
from document import Document
from gi.repository import Gtk
from gettext import gettext as _

class TahrirWindow(Gtk.ApplicationWindow):
    def __init__(self, app):
        Gtk.ApplicationWindow.__init__(self, application=app)
        self.set_title(_('Tahrir'))
        self.set_default_size(640,480)
        self.set_hide_titlebar_when_maximized(True)
        self.layout = Gtk.Box()
        self.layout.set_orientation(Gtk.Orientation.VERTICAL)
        self.mid_box = Gtk.Box(True)
        self.toolbar = toolbar = TahrirToolbar()
        self.notebook = notebook = Gtk.Notebook()
        self.notebook.set_show_tabs(False)
        self.mid_box.pack_start(notebook, True, True, 0)
        self.layout.pack_start(self.toolbar, False, False, 0)
        self.layout.pack_end(self.mid_box, True, True, 0)
        self.add(self.layout)
        self.untitledDocs = 0
        self.layout.show()
        self.mid_box.show()
        self.toolbar.show()
        self.show()

    def open_dialog(self):
        d = Gtk.FileChooserDialog('Open file', self, Gtk.FileChooserAction.OPEN, ("Cance", 0, "Open", 1))
        d.set_select_multiple(True)
        d.set_default_response(1)
        if d.run() == 1:
            filenames = d.get_filenames()
            for f in filenames:
                self.new_document(f)
        d.destroy()

    def save_request(self):
        doc = self.get_current_document()
        filename = doc.get_filename()
        if filename != None:
            doc.save()
        elif filename == None:
            d = Gtk.FileChooserDialog('Save '+doc.get_title(), self, Gtk.FileChooserAction.SAVE, ("Cance", 0, "Save", 1))
            d.set_default_response(1)
            d.set_do_overwrite_confirmation(True)
            if d.run() == 1:
                doc.set_filename(d.get_filename())
                doc.save()
            d.destroy()

    def switch_view(self, view_id):
        self.notebook.set_current_page(view_id)
        self.notebook.show_all()

    def get_current_document(self):
        current_id = self.notebook.get_current_page()
        return self.documents[current_id]
